/*
 * Decompiled with CFR 0.152.
 */
package fire.pb.map;

public abstract class BasicPos {
    private int x;
    private int y;
    private int z;
    public static final int DIR_UNKNOW = -1;
    public static final int DIR_SELF = 0;
    public static final int DIR_UP = 1;
    public static final int DIR_RIGHTUP = 2;
    public static final int DIR_RIGHT = 3;
    public static final int DIR_RIGHTDOWN = 4;
    public static final int DIR_DOWN = 5;
    public static final int DIR_LEFTDOWN = 6;
    public static final int DIR_LEFT = 7;
    public static final int DIR_LEFTUP = 8;
    public static final int DIR_NUM = 8;

    public BasicPos(int x0, int y0, int z0) {
        this.x = x0;
        this.y = y0;
        this.z = z0;
    }

    public BasicPos(int x0, int y0) {
        this.x = x0;
        this.y = y0;
        this.z = 0;
    }

    public BasicPos() {
        this.z = 0;
        this.y = 0;
        this.x = 0;
    }

    public int hashCode() {
        return (this.x << 16) + this.y;
    }

    public boolean equals(BasicPos o) {
        if (this == o) {
            return true;
        }
        if (!this.getClass().equals(o.getClass())) {
            return false;
        }
        return this.x == o.x && this.y == o.y && this.z == o.z;
    }

    public boolean isSamePos(BasicPos o) {
        return this.equals(o);
    }

    public int getX() {
        return this.x;
    }

    public int getY() {
        return this.y;
    }

    public int getZ() {
        return this.z;
    }

    public void setX(int x) {
        this.x = x;
    }

    public void setY(int y) {
        this.y = y;
    }

    public void setZ(int z) {
        this.z = z;
    }

    public int getDistance(BasicPos o) {
        int highth;
        int width = Math.abs(this.getX() - o.getX());
        return width > (highth = Math.abs(this.getY() - o.getY())) ? width : highth;
    }

    public int getDirectDistance(BasicPos to) {
        int decx = this.getX() - to.getX();
        int decy = this.getY() - to.getY();
        return (int)Math.sqrt(decx * decx + decy * decy);
    }

    public String toString() {
        return "(" + this.x + "," + this.y + "," + this.z + ")";
    }

    public short getWalkBlockType() {
        if (this.getZ() == 0) {
            return 1;
        }
        return 8;
    }

    public static int getReverseDir(int dir) {
        return (dir + 4) % 8;
    }

    public static void main(String[] args) {
    }
}

